# Morphir Decorations Editor

The Morphir Decorations Editor is a Visual Studio Code (VSCode) extension that enhances the editing experience for developers working with Morphir. It provides a tree view that reads the Intermediate Representation (IR) of your Morphir project and displays decorations for various modules, types, and values. This extension allows you to edit decorations while working with Morphir.

## Features

- **Tree View**: The Morphir Decorations Editor extension provides a tree view in the VSCode sidebar that represents the structure of your Morphir project based on its IR. It displays modules, types, and values in a hierarchical manner, allowing you to navigate and explore the different elements.

- **Edit Existing Decorations**: With the Morphir Decorations Editor, you can easily edit the existing decorations associated with modules, types, and values in your Morphir project. The extension provides a user-friendly interface to modify and customize the decorations based on your requirements.

- **Decorations Per Selection**: When you select a specific module, type, or value in the tree view, the Morphir Decorations Editor displays the associated decorations for that selection. This feature enables you to quickly identify and modify the decorations applied to individual elements of your Morphir project.

## Usage

1. Install the Morphir Decorations Editor extension from the VSCode Marketplace.

2. Open your Morphir project in VSCode.

3. In the VSCode sidebar, locate the Icon for the Morphir Decoration Editor

4. Once Icon is cliicked, locate the tree view of the various modules, types and values in the IR, in the exploerer view.

5. Explore the tree view to navigate through the modules, types, and values of your Morphir project.

6. To edit the existing decorations, select the desired module, type, or value in the tree view. The existing decorations will be displayed, and you can modify them as needed.

7. Changes are saved in edit, so the edit will be applied to the respective elements in your Morphir project.

## Benefits

The Morphir Decorations Editor extension offers several benefits to developers working with Morphir:

- **Enhanced Editing Experience**: By providing a tree view of your Morphir project's IR, the extension simplifies navigation and exploration of the project's modules, types, and values. This makes it easier to locate and work with specific elements of your Morphir codebase.

- **Efficient Decoration Management**: With the ability to edit existing decorations, the extension streamlines the process of customizing the visual representation of your Morphir code. Developers can easily attach and modify decorations, improving code readability and comprehension.

## Feedback and Contributions

We welcome your feedback, bug reports, and contributions to the Morphir Decorations Editor extension. If you have any questions or suggestions, please feel free to open an issue in the [GitHub repository](https://github.com/finos/morphir-elm/tree/main/morphir-decoration-extension). We appreciate your support in improving the extension and making it even more useful for the Morphir community.

**Enjoy!**
